//+------------------------------------------------------------------+
//|                                   FXA0 - Statistics and Odds.mq4 |
//|                            Copyright  2007 Adam J. Richter M.S. |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007 Adam J. Richter M.S."
#property link      ""

#property indicator_chart_window
#property indicator_buffers 1
#property indicator_color1 Red

int          corner=0;  //0 = top left, 1 = top right, 2 = bottom left, 3 = bottom right
extern int          top=30; //pixels from top to show information
extern int          fontSize=9; //adjust for size desired 9, 10, 11
extern color        labelColor=Green;

double ExtMapBuffer1[];
int UpBuffer[100]; //maximum number of up entries
int DownBuffer[100];  //maximum number of down entries

int i=0, a=0; //my all purpose counter
int sequenceup=0; //sequence counter
int sequencedown=0;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
  
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   ObjectMakeLabel( "mystatistics", 15, top+0 );
   ObjectMakeLabel( "mystatistics2", 15, top+15 );
   ObjectMakeLabel( "mystatistics3", 15, top+30 );
   ObjectMakeLabel( "mystatistics4", 15, top+45 );
   ObjectMakeLabel( "mystatistics5", 15, top+60 );
   ObjectMakeLabel( "mystatistics6", 15, top+75 );
//---- indicators
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
      ObjectsDeleteAll();
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int bullbars=0; //for total up bars
   int bearbars=0; //for total down bars
   int dojibars=0; //count doji bars
   int lastupbar=0, lastdownbar=0;
   double highesthigh=0, lowestlow=0, biggestbull=0, biggestbear=0, averagepips=0;
   int maxsequentialup=0, maxsequentialdown=0, countup=0, countdown=0;
   
   highesthigh=High[iHighest(NULL,0,MODE_HIGH,Bars,0)];
   lowestlow=Low[iLowest(NULL,0,MODE_LOW,Bars,0)];
   
      //clean out upbuffer, clean out downbuffer with loop
   for(i=0; i<ArraySize(UpBuffer); i++) { UpBuffer[i]=NULL; }
   for(i=0; i<ArraySize(DownBuffer); i++) { DownBuffer[i]=NULL; }
   sequenceup=0;
   sequencedown=0;
   
   for (i=Bars; i>0; i--) //cycles through the chart from beginning to current bar
   {
      if(iOpen(NULL,0,i)<iClose(NULL,0,i)) //up bar
      {
         bullbars++;
         if((iClose(NULL,0,i)-iOpen(NULL,0,i))>biggestbull) { biggestbull=iClose(NULL,0,i)-iOpen(NULL,0,i); }
         averagepips=averagepips+(iClose(NULL,0,i)-iOpen(NULL,0,i));
         
         /*if(iOpen(NULL,0,i+1)>iClose(NULL,0,i+1) && i!=Bars) { countup=0; } //if the last bar is a down bar, set counter to 0
         countup++;
         
         if(countup>maxsequentialup) { maxsequentialup=countup; }
         lastupbar=i;*/
         
        //sequence counter 
        if(sequenceup==0)
        {
           if(sequencedown>=2) { DownBuffer[sequencedown]++; }
           if(sequencedown>=maxsequentialdown) { maxsequentialdown=sequencedown; }
           sequencedown=0;
        }
        sequenceup++;
      }
      
      if(iOpen(NULL,0,i)>iClose(NULL,0,i)) //down bar
      {
         bearbars++;
         if((iOpen(NULL,0,i)-iClose(NULL,0,i))>biggestbear) { biggestbear=iOpen(NULL,0,i)-iClose(NULL,0,i); }
         averagepips=averagepips+(iOpen(NULL,0,i)-iClose(NULL,0,i));
         
         /*if(iOpen(NULL,0,i+1)<iClose(NULL,0,i+1) && i!=Bars) { countdown=0; } //if the last bar is a down bar, set counter to 0
         countdown++;
         
         if(countdown>maxsequentialdown) { maxsequentialdown=countdown; }
         lastdownbar=i;*/
         
         //sequence counter
         if(sequencedown==0) 
         {
            if(sequenceup>=2) { UpBuffer[sequenceup]++; } 
            if(sequenceup>=maxsequentialup) { maxsequentialup=sequenceup; }
            sequenceup=0;
         }
         sequencedown++;
      }
      if(iOpen(NULL,0,i)==iClose(NULL,0,i)) 
      {
         dojibars++; countdown=0; countup=0;
         
         //sequence counter
         if(sequenceup>=2) { UpBuffer[sequenceup]++; }
         if(sequencedown>=2) { DownBuffer[sequencedown]++; }
         sequenceup=0; sequencedown=0;
      }
   }
   
   //resize array for printing
   //ArrayResize(UpBuffer, maxsequentialup);
   //ArrayResize(DownBuffer, maxsequentialdown);
   
   biggestbull=biggestbull*10000;
   string biggestbulls=DoubleToStr(biggestbull,0);
   
   biggestbear=biggestbear*10000;
   string biggestbears=DoubleToStr(biggestbear,0);
   
   averagepips=averagepips/Bars;
   averagepips=averagepips*10000;
   string averagepipss=DoubleToStr(averagepips,0);
   
   string highesthighs=DoubleToStr(highesthigh,4);
   string lowestlows=DoubleToStr(lowestlow,4);
   
   ObjectSetText( "mystatistics", "Average Pips Per Bar: " + averagepipss, fontSize, "Times New Roman", labelColor );
   ObjectSetText( "mystatistics2", "Bull Bars: " + bullbars + "  Bear Bars: " + bearbars + "  Doji Bars: " + dojibars, fontSize, "Times New Roman", labelColor );
   ObjectSetText( "mystatistics3", "Highest High: " + highesthighs + "  Lowest Low: " + lowestlows, fontSize, "Times New Roman", labelColor );
   ObjectSetText( "mystatistics4", "Biggest Bull: " + biggestbulls + " pips" + "  Biggest Bear: " + biggestbears + " pips", fontSize, "Times New Roman", labelColor );
   ObjectSetText( "mystatistics5", "Max Sequential Up Bars: " + maxsequentialup + "  Max Sequential Down Bars: " + maxsequentialdown, fontSize, "Times New Roman", labelColor );
   ObjectSetText( "mystatistics6", "Sequences Up/Down", fontSize, "Times New Roman", labelColor );
   
   a=MathMax(maxsequentialup,maxsequentialdown);
   int start=105;
   for (i=2; i<=a; i++) //cycles through the chart from beginning to current bar
   {
       start=start+15;
       ObjectMakeLabel( "mystatisticsseq"+i, 15, start );
       ObjectSetText( "mystatisticsseq"+i, i+": "+UpBuffer[i]+"    "+i+": "+DownBuffer[i], fontSize, "Times New Roman", labelColor );
   }

  
  
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom Functions                                                 |
//+------------------------------------------------------------------+

int ObjectMakeLabel( string n, int xoff, int yoff ) {
   ObjectCreate( n, OBJ_LABEL, 0, 0, 0 );
   ObjectSet( n, OBJPROP_CORNER, corner );
   ObjectSet( n, OBJPROP_XDISTANCE, xoff );
   ObjectSet( n, OBJPROP_YDISTANCE, yoff );
   ObjectSet( n, OBJPROP_BACK, true );
}